Index: guiframe/local_perspectives/plotting/Plotter2D.py
===================================================================
--- guiframe/local_perspectives/plotting/Plotter2D.py	(revision ed8ad21a74d5f0d78aa329ebf8db2fd13f46d510)
+++ guiframe/local_perspectives/plotting/Plotter2D.py	(revision a07e72f8fb8281178797bf691b36e56274d8580b)
@@ -23,4 +23,5 @@
 from sans.guiframe.events import StatusEvent 
 from sans.guiframe.events import NewPlotEvent
+from sans.guiframe.events import PanelOnFocusEvent
 from sans.guiframe.events import SlicerEvent
 from sans.guiframe.utils import PanelMenu
@@ -122,4 +123,20 @@
         self.default_zmax_ctl = self.zmax_2D
        
+    def onLeftDown(self, event): 
+        """
+        left button down and ready to drag
+        
+        """
+        # Check that the LEFT button was pressed
+        if event.button == 1:
+            self.leftdown = True
+            ax = event.inaxes
+            if ax != None:
+                self.xInit, self.yInit = event.xdata, event.ydata
+        self.plottable_selected(self.data2D.id)
+       
+        self._manager.set_panel_on_focus(self)
+        wx.PostEvent(self.parent, PanelOnFocusEvent(panel=self))
+        
     def add_toolbar(self):
         """
@@ -138,5 +155,5 @@
         self.toolbar.update()
          
-    def _onEVT_1DREPLOT(self, event):
+    def plot_data(self, data):
         """
         Data is ready to be displayed
@@ -149,51 +166,14 @@
         """
         ## Update self.data2d with the current plot
-        self.data2D = event.plot
-        
-        #TODO: Check for existence of plot attribute
-        
-        # Check whether this is a replot. If we ask for a replot
-        # and the plottable no longer exists, ignore the event.
-        if hasattr(event, "update") and event.update == True \
-            and event.plot.name not in self.plots.keys():
-            return
-        if hasattr(event, "reset"):
-            self._reset()
-        is_new = True
-        if event.plot.name in self.plots.keys():
-            # Check whether the class of plottable changed
-            if not event.plot.__class__ == self.plots[event.plot.name].__class__:
-                #overwrite a plottable using the same name
-                self.graph.delete(self.plots[event.plot.name])
-            else:
-                # plottable is already draw on the panel
-                is_new = False
-           
-        if is_new:
-            # a new plottable overwrites a plotted one  using the same id
-            for plottable in self.plots.itervalues():
-                if hasattr(event.plot,"id"):
-                    if event.plot.id == plottable.id:
-                        self.graph.delete(plottable)
-            
-            self.plots[event.plot.name] = event.plot
-            self.graph.add(self.plots[event.plot.name])
+        self.data2D = data
+        if data.id in self.plots.keys():
+            #replace
+            self.graph.replace(data)
+            self.plots[data.id] = data
         else:
-            # Update the plottable with the new data
-            
-            #TODO: we should have a method to do this, 
-            #      something along the lines of:
-            #      plottable1.update_data_from_plottable(plottable2)
-            
-            self.plots[event.plot.name].xmin = event.plot.xmin
-            self.plots[event.plot.name].xmax = event.plot.xmax
-            self.plots[event.plot.name].ymin = event.plot.ymin
-            self.plots[event.plot.name].ymax = event.plot.ymax
-            self.plots[event.plot.name].data = event.plot.data
-            self.plots[event.plot.name].qx_data = event.plot.qx_data
-            self.plots[event.plot.name].qy_data = event.plot.qy_data
-            self.plots[event.plot.name].err_data = event.plot.err_data
+            self.plots[data.id] = data
+            self.graph.add(self.plots[data.id]) 
             # update qmax with the new xmax of data plotted
-            self.qmax = event.plot.xmax
+            self.qmax = data.xmax
             
         self.slicer = None
@@ -204,11 +184,11 @@
         #data2D: put 'Pixel (Number)' for axis title and unit in case of having no detector info and none in _units
         if len(self.data2D.detector) < 1: 
-            if len(event.plot._xunit) < 1 and len(event.plot._yunit) < 1:
-                event.plot._xaxis = '\\rm{x}'
-                event.plot._yaxis = '\\rm{y}'
-                event.plot._xunit = 'pixel'
-                event.plot._yunit = 'pixel'
-        self.graph.xaxis(event.plot._xaxis, event.plot._xunit)
-        self.graph.yaxis(event.plot._yaxis, event.plot._yunit)
+            if len(data._xunit) < 1 and len(data._yunit) < 1:
+                data._xaxis = '\\rm{x}'
+                data._yaxis = '\\rm{y}'
+                data._xunit = 'pixel'
+                data._yunit = 'pixel'
+        self.graph.xaxis(data._xaxis, data._xunit)
+        self.graph.yaxis(data._yaxis, data._yunit)
         self.graph.title(self.data2D.name)
         self.graph.render(self)
@@ -252,5 +232,5 @@
         if len(self.data2D.detector) == 1:        
             
-            item_list = self.parent.get_context_menu(self.graph)
+            item_list = self.parent.get_context_menu(self)
             if (not item_list == None) and (not len(item_list) == 0):
                 for item in item_list:
Index: guiframe/local_perspectives/plotting/plotting.py
===================================================================
--- guiframe/local_perspectives/plotting/plotting.py	(revision bf4402c376f8ead3899ab313483ea9aad7c66042)
+++ guiframe/local_perspectives/plotting/plotting.py	(revision a07e72f8fb8281178797bf691b36e56274d8580b)
@@ -17,4 +17,6 @@
 from sans.guiframe.events import StatusEvent 
 from sans.guiframe.plugin_base import PluginBase
+from sans.guiframe.dataFitting import Data1D
+from sans.guiframe.dataFitting import Data2D
 
 class Plugin(PluginBase):
@@ -28,5 +30,12 @@
         ## Plot panels
         self.plot_panels = []
-       
+        self.new_plot_panels = {}
+        self._panel_on_focus = None
+     
+    def set_panel_on_focus(self, panel):
+        """
+        """
+        self._panel_on_focus = panel
+        
     def is_always_active(self):
         """
@@ -76,66 +85,70 @@
         
         """
+        if hasattr(event, 'remove'):
+            group_id = event.group_id
+            id = event.id
+            if group_id in self.new_plot_panels.keys():
+                panel = self.new_plot_panels[group_id]
+                panel.remove_data_by_id(id=id)
+            else:
+                msg = "Panel with GROUP_ID: %s canot be located" % str(group_id)
+                raise ValueError, msg
+            return
         # Check whether we already have a graph with the same units
         # as the plottable we just received. 
-        is_available = False
-        for panel in self.plot_panels:
-            if event.plot._xunit == panel.graph.prop["xunit_base"] \
-            and event.plot._yunit == panel.graph.prop["yunit_base"]:
-                if hasattr(event.plot, "group_id"):
-                    ## if same group_id used the same panel to plot
-                    if not event.plot.group_id == None \
-                        and event.plot.group_id == panel.group_id:
-                        is_available = True
-                        panel._onEVT_1DREPLOT(event)
-                        self.parent.show_panel(panel.uid)   
-                else:
-                    # Check that the plot panel has no group ID
-                    ## Use a panel with group_id ==None to plot
-                    if panel.group_id == None:
-                        is_available = True
-                        panel._onEVT_1DREPLOT(event)
-                        self.parent.show_panel(panel.uid)
-        # Create a new plot panel if none was available        
-        if not is_available:
-            #print"event.plot",hasattr(event.plot,'data')
-            if not hasattr(event.plot, 'data'):
+        data = event.plot
+        
+        group_id_list = data.group_id
+        group_id = None
+        if group_id_list:
+            group_id = group_id_list[len(group_id_list)-1]
+        if group_id in self.new_plot_panels.keys():
+            panel = self.new_plot_panels[group_id]
+            _, x_unit =  data.get_xaxis()
+            _, y_unit =  data.get_yaxis()
+           
+            if x_unit != panel.graph.prop["xunit"] \
+                or  y_unit != panel.graph.prop["yunit"]:
+                msg = "Cannot add %s" % str(data.name)
+                msg += " to panel %s\n" % str(panel.window_caption)
+                msg += "Please edit %s's units, labels" % str(data.name)
+                raise ValueError, msg
+            else:
+                panel.plot_data( data)
+                self.parent.show_panel(panel.uid)   
+        else:
+            # Create a new plot panel if none was available        
+            if issubclass(data.__class__, Data1D):
                 from Plotter1D import ModelPanel1D
                 ## get the data representation label of the data to plot
                 ## when even the user select "change scale"
-                if hasattr(event.plot, "xtransform"):
-                    xtransform = event.plot.xtransform
-                else:
-                    xtransform = None
-                    
-                if hasattr(event.plot, "ytransform"):
-                    ytransform = event.plot.ytransform
-                else:
-                    ytransform = None
+                xtransform = data.xtransform
+                ytransform = data.ytransform
                 ## create a plotpanel for 1D Data
                 new_panel = ModelPanel1D(self.parent, -1, xtransform=xtransform,
                          ytransform=ytransform, style=wx.RAISED_BORDER)
-            else:
+                new_panel.set_manager(self)
+                new_panel.group_id = group_id
+            elif issubclass(data.__class__, Data2D):
                 ##Create a new plotpanel for 2D data
                 from Plotter2D import ModelPanel2D
-                if hasattr(event.plot, "scale"):
-                    scale = event.plot.scale
-                else:
-                    scale = 'log'
+                scale = data.scale
                 new_panel = ModelPanel2D(self.parent, id = -1,
                                     data2d=event.plot, scale = scale, 
                                     style=wx.RAISED_BORDER)
+                new_panel.set_manager(self)
+                new_panel.group_id = group_id
+            else:
+                msg = "Plotting received unexpected"
+                msg += " data type : %s" % str(data.__class__)
+                raise ValueError, msg
             ## Set group ID if available
             ## Assign data properties to the new create panel
-            group_id_str = ''
-            if hasattr(event.plot, "group_id"):
-                if not event.plot.group_id == None:
-                    new_panel.group_id = event.plot.group_id
-                    group_id_str = ' [%s]' % event.plot.group_id
-            if hasattr(event, "title"):
-                new_panel.window_caption = event.title
-                new_panel.window_name = event.title
+            title = data.title
+            new_panel.window_caption = title
+            new_panel.window_name = title
             event_id = self.parent.popup_panel(new_panel)
             #remove the default item in the menu
-            if len(self.plot_panels) == 0:
+            if len(self.new_plot_panels) == 0:
                 self.menu.RemoveItem(self.menu.FindItemByPosition(0))
             self.menu.Append(event_id, new_panel.window_caption, 
@@ -144,7 +157,8 @@
             new_panel.uid = event_id
             # Ship the plottable to its panel
-            new_panel._onEVT_1DREPLOT(event)
-            self.plot_panels.append(new_panel)        
+            new_panel.plot_data(data)
+            self.plot_panels.append(new_panel)       
+            self.new_plot_panels[new_panel.group_id] = new_panel
             
         return
-        
+   
Index: guiframe/plugin_base.py
===================================================================
--- guiframe/plugin_base.py	(revision 03314e7471e80689c0f7229fc1a95f0856155e0d)
+++ guiframe/plugin_base.py	(revision a07e72f8fb8281178797bf691b36e56274d8580b)
@@ -143,5 +143,5 @@
         
     
-    def get_context_menu(self, graph=None):
+    def get_context_menu(self, plotpanel=None):
         """
         This method is optional.
@@ -151,5 +151,5 @@
         chance to add a menu item to the context menu.
         
-        A ref to a Graph object is passed so that you can
+        A ref to a plotpanel object is passed so that you can
         investigate the plot content and decide whether you
         need to add items to the context menu.  
